'////////////////////////////////////////////////////////////////////////////////////////////
'//
'// PRODUCT: Norton Internet Security/Symantec Desktop Firewall
'//
'// NAME:    wiz-ALEs.vbs (VBScript file for wiz-ALEs.HTM)
'//
'// Copyright (c) 2001 by Symantec Corporation. All rights reserved.
'//
'////////////////////////////////////////////////////////////////////////////////////////////

dim nFound
dim bUserStopped
dim g_szBack
dim g_szNext
dim g_szCancel
dim g_szFinish
dim g_bFoundListLoaded
dim g_bScanStarted

' Set a few vars
g_szBack = StrID("BackB")
g_szNext = StrID("NextB")
g_szCancel = StrID("CancelB")
g_szFinish = StrID("FinishB")
g_bFoundListLoaded = false
g_bScanStarted = false
bUserStopped = 0
nFound = 0

sub Window_OnLoad()
	dialogheight = "400px"
	dialogWidth = "532px"
	returnValue = ""
	bUserStopped = 0
	PageA.style.display = ""
	BackBtn.disabled = true

	' // Watch for the FREIntegrator to run
	UserManager.WatchForFREIntegStart()

	ProdNameA.innerHTML = UserManager.AppTitle
	ProdNameB.innerHTML = UserManager.AppTitle

    ' DWong 01/26/01 Note: CheckUserType is defined in wiz-ALEs.js
	CheckUserType()

	initDriveList()
	
	OnLoad()	
	
	FixBtnText(false)
	window.focus()
end sub

sub Cancel_OnClick()
	returnValue = ""
	window.navigate("res://closeme.xyz")
end sub

sub StopBtn_OnClick()
	' Stop the scanner
	bUserStopped = 1
	NetScan.StopScan
end sub

sub FoundList_OnLoad()
	BackBtn.disabled = true
	NextBtn.disabled = true
	Cancel.disabled = true
	EnableCloseButton false

	' Insert all the application into the list
	FoundList.PutFileListAsync NetScan.FileList,OnPutFileListComplete,SetPutFileListProgress
	
	SetFileListIsLoading true
end sub

sub FoundList_OnSelect()
	dim curSel

	curSel = FoundList.CurSelCount
	if curSel > 0 then
		if curSel = 1 then
			Modify.disabled = false
		else
			Modify.disabled = true
		end if	
	else
		Modify.disabled = true
	end if
end sub

sub BackBtn_OnClick()
' Find the active page, front to back (if we are not disabled)
	if PageA.style.display = "" then
		'alert("Error")
	end if
	
	if PageB.style.display = "" then
		bUserStopped = "0"
		PageB.style.display = "none"
		PageA.style.display = ""
		BackBtn.disabled = true
		FixBtnText(false)
	end if

	if PageC.style.display = "" then
		PageC.style.display = "none"
		SetFileListIsLoading true
		PageA.style.display = ""
		BackBtn.disabled = true
		NextBtn.disabled = false
		FixBtnText(false)
		FoundList.ClearFileList()
	end if

	if PageD.style.display = "" then
		PageD.style.display = "none"
		PageC.style.display = ""
		BackBtn.disabled = false
		FixBtnText(false)
	end if

end sub

sub NetScan_OnScanStopped(when)
	g_bScanStarted = false
	Scanning.style.display = "none"
	NextBtn.disabled = false
	BackBtn.disabled = false
	Cancel.disabled = false
	StopBtn.disabled = true
	Filename.style.display = "none"
	SetProgress(0)
	pctdone.innerHTML = "&nbsp;"
	pctdone_text.style.display = "none"	
	EnableCloseButton true

	if bUserStopped = "0" then
		ScanDone.style.display = ""
		NextBtn_OnClick()
	else
		ScanStopped.style.display = ""
		FixBtnText(false)
	end if
end sub

sub NetScan_OnFileFound(count)
	ScanFound.innerHTML = count
end sub

sub NetScan_OnScanningFile(when, name)
	Filename.innerHTML = Elipse_Path(39, name)
end sub

sub NetScan_OnScanProgressUpdate(when, nPctDone)
	SetProgress(nPctDone)
end sub

function FixBtnText(bFinish)
	if bFinish = true then
		NextBtn.style.display = "none"
		FinishBtn.style.display = ""
	else
		NextBtn.style.display = ""
		FinishBtn.style.display = "none"
	end if
end function

Function makeMsgBox(title,mess,icon,buts,defbut,mods)
   butVal = buts + (icon*16) + (defbut*256) + (mods*4096)
   makeMsgBox = MsgBox(mess,butVal,title)
End Function
